libzypp: zyppng::detail::AsyncFirstOfImpl< Container, AsyncResType, Transformation, Predicate, DefaultType > Struct Template Reference

libzypp 17.36.6

Public Member Functions | Private Member Functions | Private Attributes | List of all members
zyppng::detail::AsyncFirstOfImpl< Container, AsyncResType, Transformation, Predicate, DefaultType > Struct Template Reference

`#include <zypp-core/zyppng/pipelines/algorithm.h>`

Inheritance diagram for zyppng::detail::AsyncFirstOfImpl< Container, AsyncResType, Transformation, Predicate, DefaultType >:

## Public Member Functions
| AsyncFirstOfImpl (Container &&inData, Transformation &&transFunc, DefaultType &&defaultVal, Predicate &&predicate)
Public Member Functions inherited from zyppng::AsyncOp< AsyncResType >
| AsyncOp ()=default
| AsyncOp (const AsyncOp &other)=delete
| AsyncOp (AsyncOp &&other) noexcept=default
AsyncOp & | operator= (const AsyncOp &other)=delete
AsyncOp & | operator= (AsyncOp &&other) noexcept=default
| ~AsyncOp () override
void | setReady (value_type &&val)
bool | isReady () const
void | onReady (Fun &&cb)
value_type & | get ()
Public Member Functions inherited from zyppng::AsyncOpBase
virtual bool | canCancel ()
virtual void | cancel ()
SignalProxy< void()> | sigStarted ()
SignalProxy< void(const std::string &, int, int)> | sigProgress ()
SignalProxy< void()> | sigReady ()
Public Member Functions inherited from zyppng::Base
| Base ()
virtual | ~Base ()
WeakPtr | parent () const
void | addChild (const Base::Ptr &child)
void | removeChild (const Ptr &child)
const std::unordered_set< Ptr > & | children () const
std::thread::id | threadId () const
template<typename T>
std::vector< std::weak_ptr< T > > | findChildren () const
template<typename T>
std::shared_ptr< T > | shared_this () const
template<typename T>
std::shared_ptr< T > | shared_this ()
template<typename T>
std::weak_ptr< T > | weak_this () const
template<typename T>
std::weak_ptr< T > | weak_this ()
template<typename SenderFunc, typename ReceiverFunc>
auto | connect (SenderFunc &&sFun, typename internal::MemberFunction< ReceiverFunc >::ClassType &recv, ReceiverFunc &&rFunc)
template<typename SenderFunc, typename ReceiverFunc, typename ... Tracker>
std::enable_if_t< std::is_member_function_pointer_v< SenderFunc >, connection > | connectFunc (SenderFunc &&sFun, ReceiverFunc &&rFunc, const Tracker &...trackers)

## Private Member Functions
void | execute ()
void | resultReady (AsyncResType &&res)
void | invokeCurrent ()
void | returnDefault ()

## Private Attributes
Container | _inData
Transformation | _transFunc
DefaultType | _defaultVal
Predicate | _predicate
Container::iterator | _currIter
AsyncOpRef< AsyncResType > | _currentPipeline

## Additional Inherited Members
Public Types inherited from zyppng::AsyncOp< AsyncResType >
using | value_type
using | Ptr
Public Types inherited from zyppng::Base
using | Ptr = std::shared_ptr<Base>
using | WeakPtr = std::weak_ptr<Base>
Static Public Member Functions inherited from zyppng::Base
template<typename Obj, typename Functor>
static decltype(auto) | make_base_slot (Obj *o, Functor &&f)
template<typename SenderFunc, typename ReceiverFunc>
static auto | connect (typename internal::MemberFunction< SenderFunc >::ClassType &s, SenderFunc &&sFun, typename internal::MemberFunction< ReceiverFunc >::ClassType &recv, ReceiverFunc &&rFunc)
template<typename SenderFunc, typename ReceiverFunc, typename ... Tracker>
static auto | connectFunc (typename internal::MemberFunction< SenderFunc >::ClassType &s, SenderFunc &&sFun, ReceiverFunc &&rFunc, const Tracker &...trackers)
Protected Member Functions inherited from zyppng::Base
| Base (BasePrivate &dd)
Protected Attributes inherited from zyppng::AsyncOpBase
Signal< void()> | _sigStarted
Signal< void()> | _sigReady
Signal< void(const std::string &, int, int)> | _sigProgress
Protected Attributes inherited from zyppng::Base
std::unique_ptr< BasePrivate > | d_ptr

## Detailed Description

template<class Container, class AsyncResType, class Transformation, class Predicate, class DefaultType>
struct zyppng::detail::AsyncFirstOfImpl< Container, AsyncResType, Transformation, Predicate, DefaultType >

Definition at line 37 of file algorithm.h.

## Constructor & Destructor Documentation

## ◆ AsyncFirstOfImpl()

template<class Container, class AsyncResType, class Transformation, class Predicate, class DefaultType>

zyppng::detail::AsyncFirstOfImpl< Container, AsyncResType, Transformation, Predicate, DefaultType >::AsyncFirstOfImpl | ( | Container && | inData,
|  | Transformation && | transFunc,
|  | DefaultType && | defaultVal,
|  | Predicate && | predicate )
| inline

Definition at line 39 of file algorithm.h.

## Member Function Documentation

## ◆ execute()

template<class Container, class AsyncResType, class Transformation, class Predicate, class DefaultType>

void zyppng::detail::AsyncFirstOfImpl< Container, AsyncResType, Transformation, Predicate, DefaultType >::execute | ( |  | ) |
| inlineprivate

Definition at line 47 of file algorithm.h.

## ◆ resultReady()

template<class Container, class AsyncResType, class Transformation, class Predicate, class DefaultType>

void zyppng::detail::AsyncFirstOfImpl< Container, AsyncResType, Transformation, Predicate, DefaultType >::resultReady | ( | AsyncResType && | res | ) |
| inlineprivate

Definition at line 55 of file algorithm.h.

## ◆ invokeCurrent()

template<class Container, class AsyncResType, class Transformation, class Predicate, class DefaultType>

void zyppng::detail::AsyncFirstOfImpl< Container, AsyncResType, Transformation, Predicate, DefaultType >::invokeCurrent | ( |  | ) |
| inlineprivate

Definition at line 71 of file algorithm.h.

## ◆ returnDefault()

template<class Container, class AsyncResType, class Transformation, class Predicate, class DefaultType>

void zyppng::detail::AsyncFirstOfImpl< Container, AsyncResType, Transformation, Predicate, DefaultType >::returnDefault | ( |  | ) |
| inlineprivate

Definition at line 77 of file algorithm.h.

## Member Data Documentation

## ◆ _inData

template<class Container, class AsyncResType, class Transformation, class Predicate, class DefaultType>

Container zyppng::detail::AsyncFirstOfImpl< Container, AsyncResType, Transformation, Predicate, DefaultType >::_inData
| private

Definition at line 83 of file algorithm.h.

## ◆ _transFunc

template<class Container, class AsyncResType, class Transformation, class Predicate, class DefaultType>

Transformation zyppng::detail::AsyncFirstOfImpl< Container, AsyncResType, Transformation, Predicate, DefaultType >::_transFunc
| private

Definition at line 84 of file algorithm.h.

## ◆ _defaultVal

template<class Container, class AsyncResType, class Transformation, class Predicate, class DefaultType>

DefaultType zyppng::detail::AsyncFirstOfImpl< Container, AsyncResType, Transformation, Predicate, DefaultType >::_defaultVal
| private

Definition at line 85 of file algorithm.h.

## ◆ _predicate

template<class Container, class AsyncResType, class Transformation, class Predicate, class DefaultType>

Predicate zyppng::detail::AsyncFirstOfImpl< Container, AsyncResType, Transformation, Predicate, DefaultType >::_predicate
| private

Definition at line 86 of file algorithm.h.

## ◆ _currIter

template<class Container, class AsyncResType, class Transformation, class Predicate, class DefaultType>

Container::iterator zyppng::detail::AsyncFirstOfImpl< Container, AsyncResType, Transformation, Predicate, DefaultType >::_currIter
| private

Definition at line 87 of file algorithm.h.

## ◆ _currentPipeline

template<class Container, class AsyncResType, class Transformation, class Predicate, class DefaultType>

AsyncOpRef<AsyncResType> zyppng::detail::AsyncFirstOfImpl< Container, AsyncResType, Transformation, Predicate, DefaultType >::_currentPipeline
| private

Definition at line 88 of file algorithm.h.

The documentation for this struct was generated from the following file:

- zypp-core/zyppng/pipelines/algorithm.h